const config = require('../../config');
const providers = config.providers;
const crypto = require('crypto');
const bcrypt = require('bcrypt');
const moment = require('moment');

module.exports = function (sequelize, DataTypes) {
  const pessoas_atividade = sequelize.define(
    'pessoas_atividade',
    {
      id: {
        type: DataTypes.UUID,
        defaultValue: DataTypes.UUIDV4,
        primaryKey: true,
      },

      funcao_na_atividade: {
        type: DataTypes.TEXT,
      },

      horas_previstas: {
        type: DataTypes.DECIMAL,
      },

      comentarios: {
        type: DataTypes.TEXT,
      },

      importHash: {
        type: DataTypes.STRING(255),
        allowNull: true,
        unique: true,
      },
    },
    {
      timestamps: true,
      paranoid: true,
      freezeTableName: true,
    },
  );

  pessoas_atividade.associate = (db) => {
    /// loop through entities and it's fields, and if ref === current e[name] and create relation has many on parent entity

    //end loop

    db.pessoas_atividade.belongsTo(db.estrutura_projeto, {
      as: 'estrutura',
      foreignKey: {
        name: 'estruturaId',
      },
      constraints: false,
    });

    db.pessoas_atividade.belongsTo(db.membros_equipe, {
      as: 'membro',
      foreignKey: {
        name: 'membroId',
      },
      constraints: false,
    });

    db.pessoas_atividade.belongsTo(db.clientes, {
      as: 'clientes',
      foreignKey: {
        name: 'clientesId',
      },
      constraints: false,
    });

    db.pessoas_atividade.belongsTo(db.users, {
      as: 'createdBy',
    });

    db.pessoas_atividade.belongsTo(db.users, {
      as: 'updatedBy',
    });
  };

  return pessoas_atividade;
};
